;Circus Atari...Paddle/Joystick select hack by Kurt(Nukey Shay)Howe, 2006
; features:
;           2600/7800 console autodetect
;           Controller type select toggle (Color/B&W)
;           Balloon color hues adjusted to be similar on both NTSC/PAL consoles

BLACK_BACKGROUND = 1
FIX_SCANLINES = 1

; Disassembly of Circatri.bin
; Disassembled Mon Mar 27 00:39:59 2006
; Using DiStella v2.0
; Command Line: C:\BIN\DISTELLA.EXE -pafscCircatri.cfg Circatri.bin 
; Circatri.cfg contents:
;      CODE F000 F808
;      GFX F809 FD64
;      CODE FD65 FDC3
;      GFX FDC4 FE95
;      CODE FE96 FF64
;      GFX FF65 FFFF

      processor 6502

VSYNC   =  $00
VBLANK  =  $01
WSYNC   =  $02
RSYNC   =  $03
NUSIZ0  =  $04
NUSIZ1  =  $05
COLUP0  =  $06
COLUP1  =  $07
COLUPF  =  $08
COLUBK  =  $09
CTRLPF  =  $0A
REFP1   =  $0C
PF0     =  $0D
PF1     =  $0E
PF2     =  $0F
RESP0   =  $10
RESM0   =  $12
AUDC0   =  $15
AUDF0   =  $17
AUDV0   =  $19
GRP0    =  $1B
GRP1    =  $1C
ENAM0   =  $1D
ENAM1   =  $1E
HMP0    =  $20
HMM0    =  $22
HMM1    =  $23
HMOVE   =  $2A
HMCLR   =  $2B
CXCLR   =  $2C
Waste2  =  $2E
CXM0P   =  $30
CXM1P   =  $31
CXP0FB  =  $32
CXPPMM  =  $37
INPT0   =  $38
SWCHA   =  $0280
SWCHB   =  $0282
INTIM   =  $0284
TIM64T  =  $0296

;ram $ED-upward unused (except upper bytes for stack)
;$EB now used for console type flags
;$EC now used for copy of SWCHB

       ORG $F000

LF07C:
       LDA    #$35                    ;2 #$34 in joystick version
       STA    TIM64T                  ;4
       CLC                            ;2
       LDA    $D3                     ;3
       ADC    $CD                     ;3
       STA    $CD                     ;3
       CMP    #$99                    ;2
       BCS    LF096                   ;2
       CMP    #$02                    ;2
       BCS    LF0A3                   ;2
       LDA    #$05                    ;2
       STA    $CD                     ;3
       BNE    LF09A                   ;2
LF096:
       LDA    #$98                    ;2
       STA    $CD                     ;3
LF09A:
       LDA    $D3                     ;3
       EOR    #$FF                    ;2
       CLC                            ;2
       ADC    #$01                    ;2
       STA    $D3                     ;3
LF0A3:
       STA    WSYNC                   ;3
       LDA    #$00                    ;2
       STA    $E6                     ;3
       LDA    $E5                     ;3
       AND    #$40                    ;2
       BEQ    LF0BD                   ;2
       LDA    $E5                     ;3
       AND    #$38                    ;2
       LDX    #$02                    ;2
       STX    $E6                     ;3
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       ORA    #$30                    ;2
       SEC                            ;2
LF0BD:
       STA    NUSIZ1                  ;3
       LDA    CXM1P                   ;3
       BMI    LF0C9                   ;2
       LDA    #$00                    ;2
       STA    $EA                     ;3
       BEQ    LF0D5                   ;2
LF0C9:
       LDX    $EA                     ;3
       BNE    LF0D5                   ;2
       STA    $EA                     ;3
       LDA    $D0                     ;3
       EOR    #$80                    ;2
       STA    $D0                     ;3
LF0D5:
       LDA    #$F0                    ;2
       STA    HMM1                    ;3
       STA    WSYNC                   ;3
       STA    WSYNC                   ;3
       LDA    #$00                    ;2
       STA    VSYNC                   ;3
       LDA    $CD                     ;3
       JSR    LF7BA                   ;6
;xxx
       BIT    $EB                     ;3
       BVS    LJA00                   ;2
;paddle
       LDA    $CF                     ;3
       STA    $D4                     ;3
       JMP    LJ0EA                   ;3
;joystick
LJA00:
       LDA    #$00                    ;2
       STA    VSYNC                   ;3
       LDY    $D4                     ;3
       LDA    SWCHA                   ;4
       LDX    $DD                     ;3
       CPX    #$00                    ;2
       BNE    LJA13                   ;2
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
LJA13: AND    #$0C                    ;2
       CMP    #$08                    ;2
       BNE    LJA1F                   ;2
       INY                            ;2
       INY                            ;2
       INY                            ;2
       JMP    LJA26                   ;3
LJA1F: CMP    #$04                    ;2
       BNE    LJA32                   ;2
       DEY                            ;2
       DEY                            ;2
       DEY                            ;2
LJA26: CPY    #$26                    ;2
       BCS    LJA2C                   ;2
       LDY    #$26                    ;2
LJA2C: CPY    #$96                    ;2
       BCC    LJA32                   ;2
       LDY    #$95                    ;2
LJA32: STY    $D4                     ;3
LJ0EA:


       LDA    #$00                    ;2
       STA    VSYNC                   ;3
       STA    $CF                     ;3
       LDA    $A9                     ;3
       BEQ    LF0F7                   ;2
       JMP    LF35B                   ;3
LF0F7:
       LDA    CXM0P                   ;3
       AND    #$40                    ;2
       BEQ    LF100                   ;2
       JMP    LF236                   ;3
LF100:
       LDA    CXP0FB                  ;3
       BMI    LF107                   ;2
LF104:
       JMP    LF1A4                   ;3
LF107:
       LDA    $CE                     ;3
       CMP    #$32                    ;2
       BCC    LF12F                   ;2
       LDA    #$21                    ;2
       CMP    $D1                     ;3
       BCC    LF104                   ;2
       LDA    #$80                    ;2
       STA    $D0                     ;3
       LDA    #$00                    ;2
       STA    $E1                     ;3
       LDA    #$01                    ;2
       STA    $DE                     ;3
       STA    $B7                     ;3
       LDA    #$A0                    ;2
       STA    $CE                     ;3
       LDA    $D3                     ;3
       BNE    LF1A4                   ;2
       LDA    #$01                    ;2
       STA    $D3                     ;3
       BNE    LF1A4                   ;2
LF12F:
       LDA    #$00                    ;2
       STA    $E3                     ;3
       STA    $EA                     ;3
       STA    $E2                     ;3
       LDX    $CD                     ;3
       LDA    $CE                     ;3
       JSR    LF1B0                   ;6
       LDA    $CE                     ;3
       CLC                            ;2
       SBC    #$05                    ;2
       LDX    $CD                     ;3
       JSR    LF1B0                   ;6
       LDA    $CE                     ;3
       CLC                            ;2
       SBC    #$0A                    ;2
       LDX    $CD                     ;3
       JSR    LF1B0                   ;6
       LDA    $CD                     ;3
       SEC                            ;2
       SBC    #$03                    ;2
       TAX                            ;2
       LDA    $CE                     ;3
       JSR    LF1B0                   ;6
       BNE    LF161                   ;2
       INC    $E2                     ;5
LF161:
       LDA    $CD                     ;3
       CLC                            ;2
       ADC    #$03                    ;2
       TAX                            ;2
       LDA    $CE                     ;3
       JSR    LF1B0                   ;6
       BNE    LF170                   ;2
       DEC    $E2                     ;5
LF170:
       LDA    $CD                     ;3
       SEC                            ;2
       SBC    #$03                    ;2
       TAX                            ;2
       LDA    $CE                     ;3
       CLC                            ;2
       ADC    #$0A                    ;2
       JSR    LF1B0                   ;6
       BNE    LF182                   ;2
       INC    $E2                     ;5
LF182:
       LDA    $CD                     ;3
       CLC                            ;2
       ADC    #$03                    ;2
       TAX                            ;2
       LDA    $CE                     ;3
       CLC                            ;2
       ADC    #$0A                    ;2
       JSR    LF1B0                   ;6
       BNE    LF194                   ;2
       DEC    $E2                     ;5
LF194:
       LDA    $E3                     ;3
       BEQ    LF1A4                   ;2
       LDA    $E2                     ;3
       BMI    LF1A0                   ;2
       AND    #$01                    ;2
       BPL    LF1A2                   ;2
LF1A0:
       LDA    #$FF                    ;2
LF1A2:
       STA    $D3                     ;3
LF1A4:
       LDA    $B1                     ;3
       JSR    LF775                   ;6
       LDA    #$00                    ;2
       STA    $B1                     ;3
       JMP    LF236                   ;3
LF1B0:
       TAY                            ;2
       TXA                            ;2
       PHA                            ;3
       TYA                            ;2
       CMP    #$05                    ;2
       BCC    LF1DA                   ;2
       CMP    #$0B                    ;2
       BCS    LF1C2                   ;2
LF1BC:
       CMP    #$17                    ;2
       BCS    LF1CE                   ;2
LF1C0:
       PLA                            ;4
       RTS                            ;6

LF1C2:
       CMP    #$11                    ;2
       BCS    LF1BC                   ;2
       LDX    #$8A                    ;2
       LDA    #$05                    ;2
       STA    $D2                     ;3
       BNE    LF1E0                   ;2
LF1CE:
       CMP    #$1D                    ;2
       BCS    LF1C0                   ;2
       LDA    #$02                    ;2
       STA    $D2                     ;3
       LDX    #$90                    ;2
       BNE    LF1E0                   ;2
LF1DA:
       LDA    #$0A                    ;2
       STA    $D2                     ;3
       LDX    #$84                    ;2
LF1E0:
       PLA                            ;4
       CMP    #$50                    ;2
       BCS    LF22D                   ;2
LF1E5:
       LSR                            ;2
       LSR                            ;2
       TAY                            ;2
       LDA    LF8A4,Y                 ;4
       PHA                            ;3
       AND    #$F0                    ;2
       SEC                            ;2
LF1EF:
       SBC    #$10                    ;2
       BMI    LF1F6                   ;2
       INX                            ;2
       BNE    LF1EF                   ;2
LF1F6:
       PLA                            ;4
       AND    #$0F                    ;2
       TAY                            ;2
       CLC                            ;2
       LDA    #$01                    ;2
LF1FD:
       DEY                            ;2
       BMI    LF203                   ;2
       ASL                            ;2
       BNE    LF1FD                   ;2
LF203:
       PHA                            ;3
       AND    VSYNC,X                 ;4
       BNE    LF20A                   ;2
       PLA                            ;4
       RTS                            ;6

LF20A:
       PLA                            ;4
       EOR    #$FF                    ;2
       AND    VSYNC,X                 ;4
       STA    VSYNC,X                 ;4
       LDA    $E5                     ;3
       AND    #$04                    ;2
       BNE    LF21D                   ;2
       LDA    $D0                     ;3
       EOR    #$80                    ;2
       STA    $D0                     ;3
LF21D:
       LDA    $D2                     ;3
       CLC                            ;2
       ADC    $B1                     ;3
       STA    $B1                     ;3
       LDY    #$01                    ;2
       STY    $E3                     ;3
       STY    $B5                     ;3
       LDA    #$00                    ;2
       RTS                            ;6

LF22D:
       INX                            ;2
       INX                            ;2
       INX                            ;2
       SEC                            ;2
       SBC    #$50                    ;2
       JMP    LF1E5                   ;3
LF236:
       LDA    CXM0P                   ;3
       AND    #$40                    ;2
       BNE    LF266                   ;2
       LDA    $CE                     ;3
       BNE    LF26C                   ;2
       LDA    #$00                    ;2
LF242:
       STA    $D0                     ;3
       BNE    LF26C                   ;2
LF246:
       JMP    LF30D                   ;3
LF249:
       LDA    #$80                    ;2
       STA    $D0                     ;3
       LDA    #$00                    ;2
       STA    $E1                     ;3
       LDA    #$01                    ;2
       STA    $DE                     ;3
       STA    $B7                     ;3
       LDA    #$A0                    ;2
       STA    $CE                     ;3
       LDA    $D3                     ;3
       BNE    LF263                   ;2
       LDA    #$01                    ;2
       STA    $D3                     ;3
LF263:
       JMP    LF344                   ;3
LF266:
       LDA    $CE                     ;3
       CMP    #$A1                    ;2
       BNE    LF263                   ;2
LF26C:
       CMP    #$A1                    ;2
       BNE    LF246                   ;2
       LDA    #$21                    ;2
       CMP    $D1                     ;3
       BCC    LF280                   ;2
       LDX    CXP0FB                  ;3
       BMI    LF249                   ;2
       LDA    $CD                     ;3
       CMP    #$09                    ;2
       BCC    LF249                   ;2
LF280:
       LDA    $E4                     ;3
       CMP    #$60                    ;2
       BNE    LF288                   ;2
       INC    $B9                     ;5
LF288:
       LDA    #$00                    ;2
       STA    $D3                     ;3
       LDA    $D1                     ;3
       SEC                            ;2
       SBC    #$2C                    ;2
       BMI    LF2A4                   ;2
       LDA    $81                     ;3
       AND    #$07                    ;2
       CMP    #$07                    ;2
       BNE    LF2A8                   ;2
       LDA    $D1                     ;3
       SEC                            ;2
       SBC    #$0B                    ;2
       CMP    #$21                    ;2
       BNE    LF2A6                   ;2
LF2A4:
       LDA    #$4D                    ;2
LF2A6:
       STA    $D1                     ;3
LF2A8:
       LDA    $E4                     ;3
       BEQ    LF2B1                   ;2
       DEC    $E4                     ;5
       JMP    LF30A                   ;3
LF2B1:
       LDA    $B3                     ;3
       ORA    $B8                     ;3
       ORA    $B9                     ;3
       ORA    $B2                     ;3
       ORA    $B5                     ;3
       ORA    $B4                     ;3
       ORA    $B6                     ;3
       ORA    $B7                     ;3
       ORA    $DC                     ;3
       ORA    $DB                     ;3
       BNE    LF30A                   ;2
       LDA    $AD                     ;3
       AND    #$0F                    ;2
       CMP    #$0A                    ;2
       BEQ    LF2D9                   ;2
       LDA    $AD                     ;3
       AND    #$F0                    ;2
       ORA    #$0A                    ;2
       STA    $AD                     ;3
       BNE    LF307                   ;2
LF2D9:
       LDA    $E5                     ;3
       AND    #$01                    ;2
       BEQ    LF2F8                   ;2
       JSR    LF783                   ;6
       INC    $DD                     ;5
       LDA    $AC                     ;3
       CLC                            ;2
       ADC    #$10                    ;2
       STA    $AC                     ;3
       CMP    #$3A                    ;2
       BNE    LF307                   ;2
       LDA    #$00                    ;2
       STA    $DD                     ;3
       CLC                            ;2
       ADC    #$1A                    ;2
       STA    $AC                     ;3
LF2F8:
       LDA    $AD                     ;3
       CLC                            ;2
       ADC    #$10                    ;2
       CMP    #$6A                    ;2
       BNE    LF305                   ;2
       LDA    #$01                    ;2
       STA    $A9                     ;3
LF305:
       STA    $AD                     ;3
LF307:
       JSR    LF05B                   ;6
LF30A:
       JMP    LF357                   ;3
LF30D:
       LDX    $DD                     ;3
       CMP    #$B0                    ;2
       BNE    LF320                   ;2
       LDA    $DF,X                   ;4
       CMP    #$FE                    ;2
       BEQ    LF31C                   ;2
       JMP    LF35B                   ;3
LF31C:
       ASL    $DF,X                   ;6
       STX    CXCLR                   ;3
LF320:
       LDA    $D0                     ;3
       BMI    LF33F                   ;2
       DEC    $DE                     ;5
LF326:
       LDX    $E1                     ;3
       CPX    $E9                     ;3
       BCC    LF32E                   ;2
       LDX    $E9                     ;3
LF32E:
       LDA    LF900,X                 ;4
       CLC                            ;2
       ADC    $DE                     ;3
       TAY                            ;2
       LDA    LF905,Y                 ;4
       STA    $CE                     ;3
       BNE    LF344                   ;2
       JMP    LF242                   ;3
LF33F:
       INC    $DE                     ;5
       JMP    LF326                   ;3
LF344:
       LDA    $81                     ;3
       AND    #$07                    ;2
       CMP    #$07                    ;2
       BNE    LF357                   ;2
       LDA    $D1                     ;3
       SEC                            ;2
       SBC    #$0B                    ;2
       BPL    LF355                   ;2
       LDA    #$21                    ;2
LF355:
       STA    $D1                     ;3
LF357:
       LDA    $D1                     ;3
       STA    $D6                     ;3
LF35B:
       STY    WSYNC                   ;3
       STY    HMOVE                   ;3
       STY    CXCLR                   ;3
       LDX    #$00                    ;2 color
LF36C:
       LDA    $DD                     ;3
       BNE    LF383                   ;2
       LDA    LF8B8,X                 ;4
       JSR    LF7E3                   ;6
       STA    COLUP0                  ;3
       LDY    $A9                     ;3
       BMI    LF37E                   ;2
       BNE    LF383                   ;2
LF37E:
       STA    COLUP1                  ;3
       JMP    LF391                   ;3
LF383:
       LDA    LF8B9,X                 ;4
       JSR    LF7E3                   ;6
       STA    COLUP1                  ;3
       LDY    $A9                     ;3
       BNE    LF391                   ;2
       STA    COLUP0                  ;3
LF391:
       LDA    LF8BA,X                 ;4
       JSR    LF7E3                   ;6
       STA    COLUBK                  ;3
       LDA    LF8BB,X                 ;4
       JSR    LF7E3                   ;6
       STA    COLUPF                  ;3
       LDA    LF8BC,X                 ;4
       JSR    LF7E3                   ;6
       STA    $D8                     ;3
       LDA    LF8BD,X                 ;4
       JSR    LF7E3                   ;6
       STA    $D7                     ;3
;xxx
       BIT    $EB                     ;3
       BVC    LJB20                   ;2
;joystick
       LDX    #$00                    ;2
LJB22: LDA    REFP1,X                 ;4
       ASL    $DF,X                   ;6
       EOR    #$00                    ;2
       BPL    LJB2C                   ;2
       INC    $DF,X                   ;6
LJB2C: INX                            ;2
       CPX    #$02                    ;2
       BNE    LJB22                   ;2
       BEQ    LJ3C4                   ;2
;paddle
LJB20:
       LDA    SWCHA                   ;4
       LDX    #$00                    ;2
LF3B6:
       ASL    $DF,X                   ;6
       EOR    #$00                    ;2
       BPL    LF3BE                   ;2
       INC    $DF,X                   ;6
LF3BE:
       ASL                            ;2
       INX                            ;2
       CPX    #$02                    ;2
       BNE    LF3B6                   ;2
LJ3C4:
       ASL    $80                     ;5

       LDA    SWCHB                   ;4
       TAX                            ;2
       CMP    $EC                     ;3 Compare with previous frame
       BEQ    NoColorChange           ;2 branch if the same (branch to end)
       BIT    $EB                     ;2 Is it playing on a 7800?
       BMI    A7800                   ;2 Branch if so
       EOR    $EC                     ;3 Load in the console switches
A7800:
       AND    #$08                    ;2 keep only Color/B&W
       BEQ    NoColorChange           ;2 Skip if B&W
ColorChange:
       LDA    $EB                     ;3 load a ram location used to hold
       EOR    #$40                    ;2 the Pause mode, and flip it's status
       STA    $EB                     ;3 (bit 5 of "Level" is used here)
NoColorChange:
       TXA                            ;2 get back the full array for checking other switches
       STA    $EC                     ;3


;       LDA    SWCHB                   ;4
;       CMP    $EC                     ;3
;       BEQ    NoChange                ;2
;       STA    $EC                     ;3
;NoChange:
;       LDA    SWCHB                   ;4
       AND    #$02                    ;2
       BEQ    LF3D1                   ;2
       INC    $80                     ;5
       BNE    LF416                   ;2
LF3D1:
       LDA    #$80                    ;2
       STA    $A9                     ;3
       LDA    #$00                    ;2
       STA    $DD                     ;3
       LDA    $80                     ;3
       AND    #$0F                    ;2
       CMP    #$0E                    ;2
       BEQ    LF3E5                   ;2
       DEC    $B0                     ;5
       BNE    LF416                   ;2
LF3E5:
       LDA    #$1E                    ;2
       STA    $B0                     ;3
       LDA    $E5                     ;3
       PHA                            ;3
       INC    $E8                     ;5
       LDY    $E8                     ;3
       LDA    LF809,Y                 ;4
       STA    $E5                     ;3
       PLA                            ;4
       AND    #$01                    ;2
       BEQ    LF403                   ;2
       SED                            ;2
       CLC                            ;2
       LDA    $A8                     ;3
       ADC    #$01                    ;2
       STA    $A8                     ;3
       CLD                            ;2
LF403:
       LDA    $E8                     ;3
       CMP    #$0E                    ;2
       BNE    LF416                   ;2
       LDA    #$01                    ;2
       STA    $A8                     ;3
       LDA    #$00                    ;2
       STA    $E8                     ;3
       LDA    LF809                   ;4
       STA    $E5                     ;3
LF416:
       LDA    #$40                    ;2
       LDX    $DD                     ;3
       BEQ    LF41D                   ;2
       ASL                            ;2
LF41D:
       AND    $EC                     ;3
       STA    $E7                     ;3
       LDA    $81                     ;3
       AND    #$03                    ;2
       BNE    LF437                   ;2
       LDX    #$84                    ;2
       JSR    LF66F                   ;6
       LDX    #$90                    ;2
       JSR    LF66F                   ;6
       LDX    #$8A                    ;2
       JSR    LF694                   ;6
LF437:
       ASL    $CC                     ;5
       LDA    $EC                     ;3
       AND    #$01                    ;2
       BEQ    LF442                   ;2
       INC    $CC                     ;5
LF442:
       LDA    $CC                     ;3
       CMP    #$FE                    ;2
       BNE    LF46C                   ;2
       LDA    #$00                    ;2
       STA    $A9                     ;3
       STA    $AA                     ;3
       STA    $AB                     ;3
       STA    $AE                     ;3
       STA    $DD                     ;3
       STA    $AF                     ;3
       STA    $83                     ;3
       STA    $82                     ;3
       STA    $B2                     ;3
       STA    $B3                     ;3
       STA    $D3                     ;3
       LDA    #$1A                    ;2
       STA    $AC                     ;3
       STA    $AD                     ;3
       JSR    LF04B                   ;6
       JSR    LF05B                   ;6
LF46C:
       LDA    $B6                     ;3
       BEQ    LF474                   ;2
       LDA    #$00                    ;2
       STA    $B7                     ;3
LF474:
       JSR    LF6DD                   ;6
       LDX    #$06                    ;2
       STX    $D9                     ;3
       STX    $DA                     ;3
       LDA    #$00                    ;2
       PHA                            ;3
       PHA                            ;3
       LDX    #$02                    ;2
       STX    CTRLPF                  ;3
       LDX    #$11                    ;2
LF487:
       CPX    #$0B                    ;2
       BNE    LF48E                   ;2
       LDA    $D7                     ;3
       PHA                            ;3
LF48E:
       LDA    $84,X                   ;4
       PHA                            ;3
       DEX                            ;2
       CPX    #$05                    ;2
       BNE    LF487                   ;2
       LDA    $D8                     ;3
       PHA                            ;3
       STA    HMCLR                   ;3
       LDA    #$20                    ;2
       LDY    $D5                     ;3
       BPL    LF4A3                   ;2
       LDA    #$E0                    ;2
LF4A3:
       STA    HMM0                    ;3
       LDY    #$04                    ;2
LF4A7:
       LDA    INTIM                   ;4
       BNE    LF4A7                   ;2
  IF FIX_SCANLINES = 1
       STA    Waste2                  ;3
  ELSE
       STA    WSYNC                   ;3
  ENDIF
       STA    VBLANK                  ;3
       JMP    LFD65                   ;3
LF4B3:
       STA    WSYNC                   ;3
       LDA    #$24                    ;2
       STA    TIM64T                  ;4
       LDA    #$00                    ;2
       STA    PF0                     ;3
       STA    ENAM0                   ;3
       STA    WSYNC                   ;3
       INC    $81                     ;5
       LDA    $A9                     ;3
       BNE    LF4D0                   ;2
       LDA    $DF                     ;3
       AND    $E0                     ;3
       AND    #$01                    ;2
       BEQ    LF4E2                   ;2
LF4D0:
       INC    $82                     ;5
       BNE    LF4E6                   ;2
       INC    $83                     ;5
       BNE    LF4E6                   ;2
       LDA    $A9                     ;3
       BNE    LF4E6                   ;2
       LDA    #$01                    ;2
       STA    $A9                     ;3
       BNE    LF4E6                   ;2
LF4E2:
       STA    $82                     ;3
       STA    $83                     ;3
LF4E6:
;xxx
       BIT    $EB                     ;3
       BVS    LJ500                   ;2
;paddle
       LDA    $CF                     ;3
       BEQ    LF4F4                   ;2
       CMP    #$26                    ;2
       BCS    LF4F0                   ;2
       LDA    #$26                    ;2
LF4F0:
       CMP    #$96                    ;2
       BCC    LF4F6                   ;2
LF4F4:
       LDA    #$95                    ;2
LF4F6:
       STA    $CF                     ;3
       CLC                            ;2
       ADC    $D4                     ;3
       ROR                            ;2
       STA    $D4                     ;3
       STA    $CF                     ;3
LJ500:
       LDA    CXM0P                   ;3
       AND    #$40                    ;2
       BEQ    LF568                   ;2
       LDA    CXPPMM                  ;3
       BMI    LF568                   ;2
       LDA    #$21                    ;2
       CMP    $D1                     ;3
       BCC    LF57F                   ;2
       CLC                            ;2
       LDA    $D4                     ;3
       EOR    #$FF                    ;2
       ADC    #$B9                    ;2
       ADC    $D5                     ;3
       LDX    $D5                     ;3
       BMI    LF528                   ;2
       SEC                            ;2
       SBC    $CD                     ;3
       SBC    #$07                    ;2
       BEQ    LF53F                   ;2
       BMI    LF535                   ;2
       BPL    LF539                   ;2
LF528:
       EOR    #$FF                    ;2
       CLC                            ;2
       ADC    #$01                    ;2
       ADC    #$FA                    ;2
       ADC    $CD                     ;3
       BEQ    LF53F                   ;2
       BPL    LF539                   ;2
LF535:
       INC    $E1                     ;5
       BNE    LF53F                   ;2
LF539:
       LDA    $E1                     ;3
       BEQ    LF53F                   ;2
       DEC    $E1                     ;5
LF53F:
       LDA    #$01                    ;2
       STA    $DE                     ;3
       STA    $B7                     ;3
       JSR    LF7D6                   ;6
       JSR    LF7AB                   ;6
       CLC                            ;2
       LDA    $D3                     ;3
       EOR    #$FF                    ;2
       ADC    #$01                    ;2
       STA    $D3                     ;3
       LDA    #$95                    ;2
       STA    $CE                     ;3
       LDX    #$02                    ;2
       LDA    $E7                     ;3
       BEQ    LF560                   ;2
       LDX    #$04                    ;2
LF560:
       STX    $E9                     ;3
       LDA    #$80                    ;2
       STA    $D0                     ;3
       BNE    LF57F                   ;2
LF568:
       LDA    $CE                     ;3
       CMP    #$B0                    ;2
       BEQ    LF57F                   ;2
       LDX    $DD                     ;3
       LDA    $DF,X                   ;4
       CMP    #$FE                    ;2
       BNE    LF57F                   ;2
       LDA    $CE                     ;3
       CMP    #$A1                    ;2
       BEQ    LF57F                   ;2
       JSR    LF7D6                   ;6
LF57F:
;xxx
;joystick
       LDX    $D4                     ;3
       BIT    $EB                     ;3
       BVS    LJ580                   ;2
;paddle
       LDX    $CF                     ;3 $D4 in joystick version
LJ580:
       TXA                            ;2
       LDX    #$02                    ;2
       EOR    #$FF                    ;2
       CLC                            ;2
       ADC    #$B7                    ;2
       ADC    $D5                     ;3
       STA    $CA                     ;3
       JSR    LF7BC                   ;6
       LDX    #$01                    ;2
       CLC                            ;2
       LDA    #$18                    ;2
       LDY    $D5                     ;3
       BMI    LF59C                   ;2
       EOR    #$FF                    ;2
       ADC    #$FC                    ;2
LF59C:
       ADC    $CA                     ;3
       JSR    LF7BC                   ;6
       LDY    #$03                    ;2
       LDX    #$0F                    ;2
       LDA    $A9                     ;3
       BPL    LF5D0                   ;2
       LDA    #$AA                    ;2
       STA    $AA                     ;3
       STA    $AD                     ;3
       LDA    $A8                     ;3
       AND    #$F0                    ;2
       BNE    LF5BD                   ;2
       LDA    $A8                     ;3
       AND    #$0F                    ;2
       ORA    #$A0                    ;2
       BNE    LF5BF                   ;2
LF5BD:
       LDA    $A8                     ;3
LF5BF:
       STA    $AB                     ;3
       LDA    $E5                     ;3
       AND    #$01                    ;2
       CLC                            ;2
       ADC    #$01                    ;2
       ASL                            ;2
       ASL                            ;2
       ASL                            ;2
       ASL                            ;2
       ORA    #$0A                    ;2
       STA    $AC                     ;3
LF5D0:
       LDA.wy $AA,Y                   ;4
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       JSR    LF6C7                   ;6
       DEX                            ;2
       DEX                            ;2
       LDA.wy $AA,Y                   ;4
       JSR    LF6C7                   ;6
       DEX                            ;2
       DEX                            ;2
       DEY                            ;2
       BPL    LF5D0                   ;2
       LDA    $CE                     ;3
       CMP    #$32                    ;2
       BCC    LF603                   ;2
       LDA    $E5                     ;3
       AND    #$02                    ;2
       BEQ    LF62B                   ;2
       LDX    #$84                    ;2
LF5F5:
       LDA    VSYNC,X                 ;4
       ORA    RSYNC,X                 ;4
       AND    #$F0                    ;2
       ORA    NUSIZ0,X                ;4
       ORA    WSYNC,X                 ;4
       ORA    VBLANK,X                ;4
       ORA    NUSIZ1,X                ;4
LF603:
       BNE    LF65F                   ;2
       CPX    #$90                    ;2
       BEQ    LF610                   ;2
       TXA                            ;2
       CLC                            ;2
       ADC    #$06                    ;2
       TAX                            ;2
       BNE    LF5F5                   ;2
LF610:
       JSR    LF037                   ;6
       LDX    #$84                    ;2
       JSR    LF037                   ;6
       LDX    #$8A                    ;2
       JSR    LF037                   ;6
       LDA    #$11                    ;2
       STA    $B3                     ;3
       LDA    $AD                     ;3
       AND    #$F0                    ;2
       ORA    #$0B                    ;2
       STA    $AD                     ;3
       BNE    LF65F                   ;2
LF62B:
       LDY    #$0A                    ;2
       LDX    #$84                    ;2
       JSR    LF024                   ;6
       BEQ    LF642                   ;2
       PHA                            ;3
       LDA    $AD                     ;3
       AND    #$F0                    ;2
       ORA    #$0B                    ;2
       STA    $AD                     ;3
       LDA    #$0A                    ;2
       STA    $DC                     ;3
       PLA                            ;4
LF642:
       CLC                            ;2
       ADC    $B3                     ;3
       STA    $B3                     ;3
       LDX    #$8A                    ;2
       LDY    #$05                    ;2
       JSR    LF024                   ;6
       CLC                            ;2
       ADC    $B3                     ;3
       STA    $B3                     ;3
       LDX    #$90                    ;2
       LDY    #$02                    ;2
       JSR    LF024                   ;6
       CLC                            ;2
       ADC    $B3                     ;3
       STA    $B3                     ;3
LF65F:
       LDA    INTIM                   ;4
       BNE    LF65F                   ;2
       STA    WSYNC                   ;3
       LDA    #$82                    ;2
       STA    VBLANK                  ;3
       STA    VSYNC                   ;3
       JMP    LF07C                   ;3
LF66F:
       ROR    NUSIZ1,X                ;6
       ROL    NUSIZ0,X                ;6
       ROR    RSYNC,X                 ;6
       LDA    RSYNC,X                 ;4
       AND    #$08                    ;2
       BNE    LF68E                   ;2
       CLC                            ;2
LF67C:
       ROR    WSYNC,X                 ;6
       ROL    VBLANK,X                ;6
       ROR    VSYNC,X                 ;6
       ASL    NUSIZ1,X                ;6
       LDA    VSYNC,X                 ;4
       AND    #$08                    ;2
       BNE    LF691                   ;2
       CLC                            ;2
LF68B:
       ROR    NUSIZ1,X                ;6
       RTS                            ;6

LF68E:
       SEC                            ;2
       BCS    LF67C                   ;2
LF691:
       SEC                            ;2
       BCS    LF68B                   ;2
LF694:
       ROL    VSYNC,X                 ;6
       ROR    VBLANK,X                ;6
       ROL    WSYNC,X                 ;6
       ROL    RSYNC,X                 ;6
       ROR    NUSIZ0,X                ;6
       ROL    NUSIZ1,X                ;6
       BCS    LF6BF                   ;2
LF6A2:
       LDA    RSYNC,X                 ;4
       AND    #$01                    ;2
       BEQ    LF6B0                   ;2
       LDA    RSYNC,X                 ;4
       ORA    #$10                    ;2
       AND    #$F0                    ;2
       STA    RSYNC,X                 ;4
LF6B0:
       LDA    VSYNC,X                 ;4
       AND    #$01                    ;2
       BEQ    LF6BE                   ;2
       LDA    VSYNC,X                 ;4
       ORA    #$10                    ;2
       AND    #$F0                    ;2
       STA    VSYNC,X                 ;4
LF6BE:
       RTS                            ;6

LF6BF:
       LDA    VSYNC,X                 ;4
       ORA    #$01                    ;2
       STA    VSYNC,X                 ;4
       BCS    LF6A2                   ;2
LF6C7:
       AND    #$0F                    ;2
       STA    $CA                     ;3
       ASL    $CA                     ;5
       ASL    $CA                     ;5
       CLC                            ;2
       ADC    $CA                     ;3

       ADC    #<LF8C4                 ;2
       STA    $B9,X                   ;4
       LDA    #>LF8C4                 ;2
;       ADC    #$00                    ;2 superfluous
       STA    $BA,X                   ;4
       RTS                            ;6

LF6DD:
       LDA    #$00                    ;2
       STA    AUDF0                   ;3
       STA    AUDC0                   ;3
       STA    AUDV0                   ;3
       LDA    #$17                    ;2
       STA    $CA                     ;3
       LDA    #$F8                    ;2
       STA    $CB                     ;3
LF6ED:
       LDY    #$02                    ;2
       LDA    ($CA),Y                 ;5
       TAX                            ;2
       LDA    VSYNC,X                 ;4
       BNE    LF70E                   ;2
       LDA    VBLANK,X                ;4
       BNE    LF750                   ;2
       LDY    #$00                    ;2
       LDA    ($CA),Y                 ;5
       CMP    #$17                    ;2
       BNE    LF703                   ;2
       RTS                            ;6

LF703:
       PHA                            ;3
       INY                            ;2
       LDA    ($CA),Y                 ;5
       STA    $CB                     ;3
       PLA                            ;4
       STA    $CA                     ;3
       BNE    LF6ED                   ;2
LF70E:
       LDY    #$03                    ;2
       CMP    ($CA),Y                 ;5
       BEQ    LF728                   ;2
       LDY    #$04                    ;2
       CMP    ($CA),Y                 ;5
       BEQ    LF75F                   ;2
       CLC                            ;2
       ADC    #$01                    ;2
       PHA                            ;3
       LDY    #$02                    ;2
       LDA    ($CA),Y                 ;5
       TAX                            ;2
       PLA                            ;4
       STA    VSYNC,X                 ;4
       BNE    LF738                   ;2
LF728:
       LDY    #$02                    ;2
       LDA    ($CA),Y                 ;5
       TAX                            ;2
       LDA    VBLANK,X                ;4
       BNE    LF76A                   ;2
       LDA    VSYNC,X                 ;4
       CLC                            ;2
       ADC    #$01                    ;2
       STA    VSYNC,X                 ;4
LF738:
       TAY                            ;2
       LDA    ($CA),Y                 ;5
       PHA                            ;3
       AND    #$0F                    ;2
       STA    AUDV0                   ;3
       PLA                            ;4
       ROR                            ;2
       ROR                            ;2
       ROR                            ;2
       ROR                            ;2
       AND    #$0F                    ;2
       STA    AUDF0                   ;3
       LDY    #$06                    ;2
       LDA    ($CA),Y                 ;5
       STA    AUDC0                   ;3
LF74F:
       RTS                            ;6

LF750:
       DEC    VBLANK,X                ;6
       LDY    #$05                    ;2
       LDA    ($CA),Y                 ;5
       BEQ    LF75B                   ;2
       JSR    LF771                   ;6
LF75B:
       LDA    #$07                    ;2
       BNE    LF70E                   ;2
LF75F:
       LDY    #$02                    ;2
       LDA    ($CA),Y                 ;5
       TAX                            ;2
       LDA    #$00                    ;2
       STA    VSYNC,X                 ;4
       BEQ    LF74F                   ;2
LF76A:
       LDA    #$00                    ;2
       STA    VSYNC,X                 ;4
       JMP    LF6ED                   ;3
LF771:
       LDY    #$05                    ;2
       LDA    ($CA),Y                 ;5
LF775:
       SED                            ;2
       CLC                            ;2
       ADC    $AB                     ;3
       STA    $AB                     ;3
       LDA    $AA                     ;3
       ADC    #$00                    ;2
       STA    $AA                     ;3
       CLD                            ;2
       RTS                            ;6

LF783:
       LDA    $E5                     ;3
       AND    #$80                    ;2
       BNE    LF79A                   ;2
       LDY    #$84                    ;2
LF78B:
       LDA.wy VSYNC,Y                 ;4
       LDX    RESM0,Y                 ;4
       STA.wy RESM0,Y                 ;5
       STX    VSYNC,Y                 ;4
       INY                            ;2
       CPY    #$96                    ;2
       BNE    LF78B                   ;2
LF79A:
       LDA    $AA                     ;3
       LDX    $AE                     ;3
       STX    $AA                     ;3
       STA    $AE                     ;3
       LDA    $AB                     ;3
       LDX    $AF                     ;3
       STX    $AB                     ;3
       STA    $AF                     ;3
       RTS                            ;6

LF7AB:
       CLC                            ;2
       LDA    #$00                    ;2
       LDX    $D5                     ;3
       BEQ    LF7B3                   ;2
       TXA                            ;2
LF7B3:
       ADC    #$B8                    ;2
       SEC                            ;2
       SBC    $D4                     ;3
       STA    $CD                     ;3
LF7BA:
       LDX    #$00                    ;2
LF7BC:
       LDY    #$02                    ;2
       SEC                            ;2
LF7BF:
       INY                            ;2
       SBC    #$0F                    ;2
       BCS    LF7BF                   ;2
       EOR    #$FF                    ;2
       SBC    #$06                    ;2
       ASL                            ;2
       ASL                            ;2
       ASL                            ;2
       ASL                            ;2
       STY    WSYNC                   ;3
LF7CE:
       DEY                            ;2
       BPL    LF7CE                   ;2
       STA    RESP0,X                 ;4
       STA    HMP0,X                  ;4
       RTS                            ;6

LF7D6:
       LDX    #$04                    ;2
       LDA    $D5                     ;3
       BPL    LF7DF                   ;2
LF7DC:
       STX    $D5                     ;3
       RTS                            ;6

LF7DF:
       LDX    #$E8                    ;2
       BNE    LF7DC                   ;2
LF7E3:
       LDY    $A9                     ;3
       BEQ    LF801                   ;2
       STA    $CA                     ;3
       LDA    #$00                    ;2
       STA    $B2                     ;3
       STA    $B3                     ;3
       LDA    $AE                     ;3
       STA    $AC                     ;3
       LDA    $AF                     ;3
       STA    $AD                     ;3
       LDA    $83                     ;3
       CPX    #$06                    ;2
       BEQ    LF804                   ;2
       EOR    $CA                     ;3
       AND    #$F7                    ;2
LF801:
       EOR    #$00                    ;2
       RTS                            ;6

LF804:
       EOR    $CA                     ;3
       AND    #$07                    ;2
       RTS                            ;6






       ORG $F809

LF809:
       .byte $00 ; |        | $F809
       .byte $01 ; |       X| $F80A
       .byte $70 ; | XXX    | $F80B
       .byte $71 ; | XXX   X| $F80C
       .byte $04 ; |     X  | $F80D
       .byte $05 ; |     X X| $F80E
       .byte $74 ; | XXX X  | $F80F
       .byte $75 ; | XXX X X| $F810
       .byte $02 ; |      X | $F811
       .byte $03 ; |      XX| $F812
       .byte $72 ; | XXX  X | $F813
       .byte $73 ; | XXX  XX| $F814
       .byte $81 ; |X      X| $F815
       .byte $F1 ; |XXXX   X| $F816
       .byte $2E ; |  X XXX | $F817
       .byte $F8 ; |XXXXX   | $F818
       .byte $B6 ; |X XX XX | $F819
       .byte $15 ; |   X X X| $F81A
       .byte $14 ; |   X X  | $F81B
       .byte $01 ; |       X| $F81C
       .byte $07 ; |     XXX| $F81D
       .byte $FF ; |XXXXXXXX| $F81E
       .byte $FE ; |XXXXXXX | $F81F
       .byte $FD ; |XXXXXX X| $F820
       .byte $FC ; |XXXXXX  | $F821
       .byte $FB ; |XXXXX XX| $F822
       .byte $FA ; |XXXXX X | $F823
       .byte $F9 ; |XXXXX  X| $F824
       .byte $F8 ; |XXXXX   | $F825
       .byte $F7 ; |XXXX XXX| $F826
       .byte $F6 ; |XXXX XX | $F827
       .byte $F5 ; |XXXX X X| $F828
       .byte $F4 ; |XXXX X  | $F829
       .byte $F3 ; |XXXX  XX| $F82A
       .byte $F2 ; |XXXX  X | $F82B
       .byte $F1 ; |XXXX   X| $F82C
       .byte $F0 ; |XXXX    | $F82D
       .byte $45 ; | X   X X| $F82E
       .byte $F8 ; |XXXXX   | $F82F
       .byte $B4 ; |X XX X  | $F830
       .byte $15 ; |   X X X| $F831
       .byte $16 ; |   X XX | $F832
       .byte $00 ; |        | $F833
       .byte $08 ; |    X   | $F834
       .byte $11 ; |   X   X| $F835
       .byte $FF ; |XXXXXXXX| $F836
       .byte $22 ; |  X   X | $F837
       .byte $EE ; |XXX XXX | $F838
       .byte $33 ; |  XX  XX| $F839
       .byte $DD ; |XX XXX X| $F83A
       .byte $44 ; | X   X  | $F83B
       .byte $CC ; |XX  XX  | $F83C
       .byte $55 ; | X X X X| $F83D
       .byte $BB ; |X XXX XX| $F83E
       .byte $66 ; | XX  XX | $F83F
       .byte $AA ; |X X X X | $F840
       .byte $77 ; | XXX XXX| $F841
       .byte $99 ; |X  XX  X| $F842
       .byte $88 ; |X   X   | $F843
       .byte $88 ; |X   X   | $F844
       .byte $6E ; | XX XXX | $F845
       .byte $F8 ; |XXXXX   | $F846
       .byte $B8 ; |X XXX   | $F847
       .byte $22 ; |  X   X | $F848
       .byte $23 ; |  X   XX| $F849
       .byte $00 ; |        | $F84A
       .byte $08 ; |    X   | $F84B
       .byte $AF ; |X X XXXX| $F84C
       .byte $AE ; |X X XXX | $F84D
       .byte $AF ; |X X XXXX| $F84E
       .byte $AE ; |X X XXX | $F84F
       .byte $AD ; |X X XX X| $F850
       .byte $AE ; |X X XXX | $F851
       .byte $AD ; |X X XX X| $F852
       .byte $AC ; |X X XX  | $F853
       .byte $AD ; |X X XX X| $F854
       .byte $AE ; |X X XXX | $F855
       .byte $AD ; |X X XX X| $F856
       .byte $AC ; |X X XX  | $F857
       .byte $AB ; |X X X XX| $F858
       .byte $AA ; |X X X X | $F859
       .byte $AB ; |X X X XX| $F85A
       .byte $AA ; |X X X X | $F85B
       .byte $A9 ; |X X X  X| $F85C
       .byte $AA ; |X X X X | $F85D
       .byte $A9 ; |X X X  X| $F85E
       .byte $A8 ; |X X X   | $F85F
       .byte $A9 ; |X X X  X| $F860
       .byte $A7 ; |X X  XXX| $F861
       .byte $A8 ; |X X X   | $F862
       .byte $A7 ; |X X  XXX| $F863
       .byte $A6 ; |X X  XX | $F864
       .byte $A7 ; |X X  XXX| $F865
       .byte $A6 ; |X X  XX | $F866
       .byte $A5 ; |X X  X X| $F867
       .byte $A6 ; |X X  XX | $F868
       .byte $A5 ; |X X  X X| $F869
       .byte $A4 ; |X X  X  | $F86A
       .byte $A3 ; |X X   XX| $F86B
       .byte $A2 ; |X X   X | $F86C
       .byte $A1 ; |X X    X| $F86D
       .byte $85 ; |X    X X| $F86E
       .byte $F8 ; |XXXXX   | $F86F
       .byte $DB ; |XX XX XX| $F870
       .byte $14 ; |   X X  | $F871
       .byte $15 ; |   X X X| $F872
       .byte $00 ; |        | $F873
       .byte $0C ; |    XX  | $F874
       .byte $EE ; |XXX XXX | $F875
       .byte $00 ; |        | $F876
       .byte $EE ; |XXX XXX | $F877
       .byte $00 ; |        | $F878
       .byte $00 ; |        | $F879
       .byte $DD ; |XX XXX X| $F87A
       .byte $00 ; |        | $F87B
       .byte $00 ; |        | $F87C
       .byte $EE ; |XXX XXX | $F87D
       .byte $EE ; |XXX XXX | $F87E
       .byte $FF ; |XXXXXXXX| $F87F
       .byte $FF ; |XXXXXXXX| $F880
       .byte $00 ; |        | $F881
       .byte $AA ; |X X X X | $F882
       .byte $00 ; |        | $F883
       .byte $AA ; |X X X X | $F884
       .byte $17 ; |   X XXX| $F885
       .byte $F8 ; |XXXXX   | $F886
       .byte $B2 ; |X XX  X | $F887
       .byte $0A ; |    X X | $F888
       .byte $1E ; |   XXXX | $F889
       .byte $0A ; |    X X | $F88A
       .byte $0C ; |    XX  | $F88B
       .byte $1F ; |   XXXXX| $F88C
       .byte $2E ; |  X XXX | $F88D
       .byte $3D ; |  XXXX X| $F88E
       .byte $4C ; | X  XX  | $F88F
       .byte $5B ; | X XX XX| $F890
       .byte $6A ; | XX X X | $F891
       .byte $79 ; | XXXX  X| $F892
       .byte $88 ; |X   X   | $F893
       .byte $97 ; |X  X XXX| $F894
       .byte $A6 ; |X X  XX | $F895
       .byte $B5 ; |X XX X X| $F896
       .byte $C4 ; |XX   X  | $F897
       .byte $D3 ; |XX X  XX| $F898
       .byte $E2 ; |XXX   X | $F899
       .byte $F1 ; |XXXX   X| $F89A
       .byte $11 ; |   X   X| $F89B
       .byte $22 ; |  X   X | $F89C
       .byte $33 ; |  XX  XX| $F89D
       .byte $44 ; | X   X  | $F89E
       .byte $55 ; | X X X X| $F89F
       .byte $66 ; | XX  XX | $F8A0
       .byte $77 ; | XXX XXX| $F8A1
       .byte $88 ; |X   X   | $F8A2
       .byte $99 ; |X  XX  X| $F8A3
LF8A4:
       .byte $04 ; |     X  | $F8A4
       .byte $05 ; |     X X| $F8A5
       .byte $06 ; |     XX | $F8A6
       .byte $07 ; |     XXX| $F8A7
       .byte $17 ; |   X XXX| $F8A8
       .byte $16 ; |   X XX | $F8A9
       .byte $15 ; |   X X X| $F8AA
       .byte $14 ; |   X X  | $F8AB
       .byte $13 ; |   X  XX| $F8AC
       .byte $12 ; |   X  X | $F8AD
       .byte $11 ; |   X   X| $F8AE
       .byte $10 ; |   X    | $F8AF
       .byte $20 ; |  X     | $F8B0
       .byte $21 ; |  X    X| $F8B1
       .byte $22 ; |  X   X | $F8B2
       .byte $23 ; |  X   XX| $F8B3
       .byte $24 ; |  X  X  | $F8B4
       .byte $25 ; |  X  X X| $F8B5
       .byte $26 ; |  X  XX | $F8B6
       .byte $27 ; |  X  XXX| $F8B7

;colors
LF8B8:
       .byte $5A ; | X XX X | $F8B8 player 1 color
LF8B9:
       .byte $CD ; |XX  XX X| $F8B9 player 2 color
LF8BA:
  IF BLACK_BACKGROUND
       .byte $00 ; |        | $F8BA background color
  ELSE
       .byte $90 ; |X  X    | $F8BA background color
  ENDIF
LF8BB:
       .byte $44 ; | X   X  | $F8BB red balloon
LF8BC:
       .byte $96 ; |X    XX | $F8BC blue balloon
LF8BD:
       .byte $2C ; |XXXXXXXX| $F8BD yellow balloon

LF8C4:
       .byte $E7 ; |XXX  XXX| $F8C4
       .byte $A5 ; |X X  X X| $F8C5
       .byte $A5 ; |X X  X X| $F8C6
       .byte $A5 ; |X X  X X| $F8C7
       .byte $E7 ; |XXX  XXX| $F8C8
       .byte $42 ; | X    X | $F8C9
       .byte $42 ; | X    X | $F8CA
       .byte $42 ; | X    X | $F8CB
       .byte $42 ; | X    X | $F8CC
       .byte $42 ; | X    X | $F8CD
       .byte $E7 ; |XXX  XXX| $F8CE
       .byte $81 ; |X      X| $F8CF
       .byte $E7 ; |XXX  XXX| $F8D0
       .byte $24 ; |  X  X  | $F8D1
       .byte $E7 ; |XXX  XXX| $F8D2
       .byte $E7 ; |XXX  XXX| $F8D3
       .byte $24 ; |  X  X  | $F8D4
       .byte $66 ; | XX  XX | $F8D5
       .byte $24 ; |  X  X  | $F8D6
       .byte $E7 ; |XXX  XXX| $F8D7
       .byte $24 ; |  X  X  | $F8D8
       .byte $24 ; |  X  X  | $F8D9
       .byte $E7 ; |XXX  XXX| $F8DA
       .byte $A5 ; |X X  X X| $F8DB
       .byte $81 ; |X      X| $F8DC
       .byte $E7 ; |XXX  XXX| $F8DD
       .byte $24 ; |  X  X  | $F8DE
       .byte $E7 ; |XXX  XXX| $F8DF
       .byte $81 ; |X      X| $F8E0
       .byte $E7 ; |XXX  XXX| $F8E1
       .byte $E7 ; |XXX  XXX| $F8E2
       .byte $A5 ; |X X  X X| $F8E3
       .byte $E7 ; |XXX  XXX| $F8E4
       .byte $81 ; |X      X| $F8E5
       .byte $E7 ; |XXX  XXX| $F8E6
       .byte $24 ; |  X  X  | $F8E7
       .byte $24 ; |  X  X  | $F8E8
       .byte $24 ; |  X  X  | $F8E9
       .byte $24 ; |  X  X  | $F8EA
       .byte $E7 ; |XXX  XXX| $F8EB
       .byte $E7 ; |XXX  XXX| $F8EC
       .byte $A5 ; |X X  X X| $F8ED
       .byte $E7 ; |XXX  XXX| $F8EE
       .byte $A5 ; |X X  X X| $F8EF
       .byte $E7 ; |XXX  XXX| $F8F0
       .byte $E7 ; |XXX  XXX| $F8F1
       .byte $24 ; |  X  X  | $F8F2
       .byte $E7 ; |XXX  XXX| $F8F3
       .byte $A5 ; |X X  X X| $F8F4
       .byte $E7 ; |XXX  XXX| $F8F5
       .byte $00 ; |        | $F8F6
       .byte $00 ; |        | $F8F7
       .byte $00 ; |        | $F8F8
       .byte $00 ; |        | $F8F9
       .byte $00 ; |        | $F8FA
       .byte $A5 ; |X X  X X| $F8FB
       .byte $A5 ; |X X  X X| $F8FC
       .byte $42 ; | X    X | $F8FD
       .byte $A5 ; |X X  X X| $F8FE
       .byte $A5 ; |X X  X X| $F8FF


       ORG $F900

LF900:
       .byte $00 ; |        | $F900
       .byte $28 ; |  X X   | $F901
       .byte $58 ; | X XX   | $F902
       .byte $82 ; |X     X | $F903
       .byte $A4 ; |X X  X  | $F904
LF905:
       .byte $A1 ; |X X    X| $F905
       .byte $98 ; |X  XX   | $F906
       .byte $92 ; |X  X  X | $F907
       .byte $8C ; |X   XX  | $F908
       .byte $87 ; |X    XXX| $F909
       .byte $81 ; |X      X| $F90A
       .byte $7C ; | XXXXX  | $F90B
       .byte $77 ; | XXX XXX| $F90C
       .byte $72 ; | XXX  X | $F90D
       .byte $6D ; | XX XX X| $F90E
       .byte $68 ; | XX X   | $F90F
       .byte $64 ; | XX  X  | $F910
       .byte $5F ; | X XXXXX| $F911
       .byte $5B ; | X XX XX| $F912
       .byte $57 ; | X X XXX| $F913
       .byte $53 ; | X X  XX| $F914
       .byte $4F ; | X  XXXX| $F915
       .byte $4B ; | X  X XX| $F916
       .byte $48 ; | X  X   | $F917
       .byte $45 ; | X   X X| $F918
       .byte $42 ; | X    X | $F919
       .byte $3F ; |  XXXXXX| $F91A
       .byte $3C ; |  XXXX  | $F91B
       .byte $3A ; |  XXX X | $F91C
       .byte $37 ; |  XX XXX| $F91D
       .byte $35 ; |  XX X X| $F91E
       .byte $33 ; |  XX  XX| $F91F
       .byte $31 ; |  XX   X| $F920
       .byte $2F ; |  X XXXX| $F921
       .byte $2D ; |  X XX X| $F922
       .byte $2B ; |  X X XX| $F923
       .byte $2A ; |  X X X | $F924
       .byte $29 ; |  X X  X| $F925
       .byte $28 ; |  X X   | $F926
       .byte $27 ; |  X  XXX| $F927
       .byte $26 ; |  X  XX | $F928
       .byte $25 ; |  X  X X| $F929
       .byte $25 ; |  X  X X| $F92A
       .byte $24 ; |  X  X  | $F92B
       .byte $00 ; |        | $F92C
       .byte $A1 ; |X X    X| $F92D
       .byte $98 ; |X  XX   | $F92E
       .byte $92 ; |X  X  X | $F92F
       .byte $8C ; |X   XX  | $F930
       .byte $87 ; |X    XXX| $F931
       .byte $81 ; |X      X| $F932
       .byte $7B ; | XXXX XX| $F933
       .byte $76 ; | XXX XX | $F934
       .byte $71 ; | XXX   X| $F935
       .byte $6C ; | XX XX  | $F936
       .byte $67 ; | XX  XXX| $F937
       .byte $62 ; | XX   X | $F938
       .byte $5D ; | X XXX X| $F939
       .byte $59 ; | X XX  X| $F93A
       .byte $54 ; | X X X  | $F93B
       .byte $50 ; | X X    | $F93C
       .byte $4B ; | X  X XX| $F93D
       .byte $47 ; | X   XXX| $F93E
       .byte $43 ; | X    XX| $F93F
       .byte $3F ; |  XXXXXX| $F940
       .byte $3B ; |  XXX XX| $F941
       .byte $38 ; |  XXX   | $F942
       .byte $34 ; |  XX X  | $F943
       .byte $31 ; |  XX   X| $F944
       .byte $2D ; |  X XX X| $F945
       .byte $2A ; |  X X X | $F946
       .byte $27 ; |  X  XXX| $F947
       .byte $24 ; |  X  X  | $F948
       .byte $21 ; |  X    X| $F949
       .byte $1E ; |   XXXX | $F94A
       .byte $1C ; |   XXX  | $F94B
       .byte $19 ; |   XX  X| $F94C
       .byte $17 ; |   X XXX| $F94D
       .byte $15 ; |   X X X| $F94E
       .byte $12 ; |   X  X | $F94F
       .byte $10 ; |   X    | $F950
       .byte $0F ; |    XXXX| $F951
       .byte $0D ; |    XX X| $F952
       .byte $0B ; |    X XX| $F953
       .byte $0A ; |    X X | $F954
       .byte $08 ; |    X   | $F955
       .byte $07 ; |     XXX| $F956
       .byte $06 ; |     XX | $F957
       .byte $04 ; |     X  | $F958
       .byte $03 ; |      XX| $F959
       .byte $02 ; |      X | $F95A
       .byte $01 ; |       X| $F95B
       .byte $00 ; |        | $F95C
       .byte $A1 ; |X X    X| $F95D
       .byte $98 ; |X  XX   | $F95E
       .byte $91 ; |X  X   X| $F95F
       .byte $8A ; |X   X X | $F960
       .byte $84 ; |X    X  | $F961
       .byte $7D ; | XXXXX X| $F962
       .byte $77 ; | XXX XXX| $F963
       .byte $71 ; | XXX   X| $F964
       .byte $6B ; | XX X XX| $F965
       .byte $65 ; | XX  X X| $F966
       .byte $60 ; | XX     | $F967
       .byte $5A ; | X XX X | $F968
       .byte $55 ; | X X X X| $F969
       .byte $50 ; | X X    | $F96A
       .byte $4B ; | X  X XX| $F96B
       .byte $46 ; | X   XX | $F96C
       .byte $41 ; | X     X| $F96D
       .byte $3D ; |  XXXX X| $F96E
       .byte $38 ; |  XXX   | $F96F
       .byte $34 ; |  XX X  | $F970
       .byte $30 ; |  XX    | $F971
       .byte $2C ; |  X XX  | $F972
       .byte $29 ; |  X X  X| $F973
       .byte $25 ; |  X  X X| $F974
       .byte $22 ; |  X   X | $F975
       .byte $1F ; |   XXXXX| $F976
       .byte $1B ; |   XX XX| $F977
       .byte $18 ; |   XX   | $F978
       .byte $16 ; |   X XX | $F979
       .byte $13 ; |   X  XX| $F97A
       .byte $11 ; |   X   X| $F97B
       .byte $0F ; |    XXXX| $F97C
       .byte $0C ; |    XX  | $F97D
       .byte $0B ; |    X XX| $F97E
       .byte $09 ; |    X  X| $F97F
       .byte $07 ; |     XXX| $F980
       .byte $06 ; |     XX | $F981
       .byte $04 ; |     X  | $F982
       .byte $03 ; |      XX| $F983
       .byte $02 ; |      X | $F984
       .byte $01 ; |       X| $F985
       .byte $00 ; |        | $F986
       .byte $A1 ; |X X    X| $F987
       .byte $98 ; |X  XX   | $F988
       .byte $8F ; |X   XXXX| $F989
       .byte $87 ; |X    XXX| $F98A
       .byte $7E ; | XXXXXX | $F98B
       .byte $76 ; | XXX XX | $F98C
       .byte $6E ; | XX XXX | $F98D
       .byte $67 ; | XX  XXX| $F98E
       .byte $60 ; | XX     | $F98F
       .byte $59 ; | X XX  X| $F990
       .byte $52 ; | X X  X | $F991
       .byte $4B ; | X  X XX| $F992
       .byte $45 ; | X   X X| $F993
       .byte $3F ; |  XXXXXX| $F994
       .byte $3A ; |  XXX X | $F995
       .byte $34 ; |  XX X  | $F996
       .byte $2F ; |  X XXXX| $F997
       .byte $2A ; |  X X X | $F998
       .byte $26 ; |  X  XX | $F999
       .byte $21 ; |  X    X| $F99A
       .byte $1D ; |   XXX X| $F99B
       .byte $19 ; |   XX  X| $F99C
       .byte $16 ; |   X XX | $F99D
       .byte $12 ; |   X  X | $F99E
       .byte $0F ; |    XXXX| $F99F
       .byte $0C ; |    XX  | $F9A0
       .byte $0A ; |    X X | $F9A1
       .byte $08 ; |    X   | $F9A2
       .byte $06 ; |     XX | $F9A3
       .byte $04 ; |     X  | $F9A4
       .byte $03 ; |      XX| $F9A5
       .byte $02 ; |      X | $F9A6
       .byte $01 ; |       X| $F9A7
       .byte $00 ; |        | $F9A8
       .byte $A1 ; |X X    X| $F9A9
       .byte $98 ; |X  XX   | $F9AA
       .byte $8E ; |X   XXX | $F9AB
       .byte $84 ; |X    X  | $F9AC
       .byte $7B ; | XXXX XX| $F9AD
       .byte $73 ; | XXX  XX| $F9AE
       .byte $6A ; | XX X X | $F9AF
       .byte $62 ; | XX   X | $F9B0
       .byte $5A ; | X XX X | $F9B1
       .byte $52 ; | X X  X | $F9B2
       .byte $4B ; | X  X XX| $F9B3
       .byte $44 ; | X   X  | $F9B4
       .byte $3E ; |  XXXXX | $F9B5
       .byte $37 ; |  XX XXX| $F9B6
       .byte $31 ; |  XX   X| $F9B7

       .byte $2C ; |  X XX  | $F9B8
       .byte $27 ; |  X  XXX| $F9B9
       .byte $22 ; |  X   X | $F9BA
       .byte $1D ; |   XXX X| $F9BB
       .byte $19 ; |   XX  X| $F9BC
       .byte $15 ; |   X X X| $F9BD
       .byte $11 ; |   X   X| $F9BE
       .byte $0E ; |    XXX | $F9BF
       .byte $0B ; |    X XX| $F9C0
       .byte $08 ; |    X   | $F9C1
       .byte $06 ; |     XX | $F9C2
       .byte $04 ; |     X  | $F9C3
       .byte $02 ; |      X | $F9C4
       .byte $01 ; |       X| $F9C5
LFCB8:
       .byte $00 ; |        | $F9C6
       .byte $00 ; |        | $F9C7
       .byte $00 ; |        | $F9C8
       .byte $00 ; |        | $F9C9
       .byte $00 ; |        | $F9CA
       .byte $00 ; |        | $F9CB
       .byte $00 ; |        | $F9CC
       .byte $00 ; |        | $F9CD
       .byte $00 ; |        | $F9CE
       .byte $00 ; |        | $F9CF
       .byte $00 ; |        | $F9D0
       .byte $00 ; |        | $F9D1
       .byte $00 ; |        | $F9D2
       .byte $00 ; |        | $F9D3
       .byte $00 ; |        | $F9D4
       .byte $00 ; |        | $F9D5
       .byte $00 ; |        | $F9D6
       .byte $00 ; |        | $F9D7
       .byte $00 ; |        | $F9D8
       .byte $00 ; |        | $F9D9
       .byte $00 ; |        | $F9DA
       .byte $00 ; |        | $F9DB
       .byte $00 ; |        | $F9DC
       .byte $00 ; |        | $F9DD
       .byte $00 ; |        | $F9DE
       .byte $00 ; |        | $F9DF
       .byte $00 ; |        | $F9E0
       .byte $00 ; |        | $F9E1
       .byte $00 ; |        | $F9E2
       .byte $00 ; |        | $F9E3
       .byte $00 ; |        | $F9E4
       .byte $00 ; |        | $F9E5
       .byte $00 ; |        | $F9E6
       .byte $00 ; |        | $F9E7
       .byte $00 ; |        | $F9E8
       .byte $00 ; |        | $F9E9
       .byte $00 ; |        | $F9EA
       .byte $00 ; |        | $F9EB
       .byte $00 ; |        | $F9EC
       .byte $00 ; |        | $F9ED
       .byte $00 ; |        | $F9EE
       .byte $00 ; |        | $F9EF
       .byte $00 ; |        | $F9F0
       .byte $00 ; |        | $F9F1
       .byte $00 ; |        | $F9F2
       .byte $00 ; |        | $F9F3
       .byte $00 ; |        | $F9F4
       .byte $00 ; |        | $F9F5
       .byte $00 ; |        | $F9F6
       .byte $00 ; |        | $F9F7
       .byte $00 ; |        | $F9F8
       .byte $00 ; |        | $F9F9
       .byte $00 ; |        | $F9FA
       .byte $00 ; |        | $F9FB
       .byte $00 ; |        | $F9FC
       .byte $00 ; |        | $F9FD
       .byte $00 ; |        | $F9FE
       .byte $00 ; |        | $F9FF



       .byte $00 ; |        | $F9F2
       .byte $00 ; |        | $F9F3
       .byte $00 ; |        | $F9F4
       .byte $00 ; |        | $F9F5
       .byte $00 ; |        | $F9F6
       .byte $00 ; |        | $F9F7
       .byte $00 ; |        | $F9F8
       .byte $00 ; |        | $F9F9
       .byte $00 ; |        | $F9FA
       .byte $00 ; |        | $F9FB
       .byte $00 ; |        | $F9FC
       .byte $00 ; |        | $F9FD
       .byte $00 ; |        | $F9FE
       .byte $00 ; |        | $F9FF

LFD00:
       .byte $00 ; |        | $FD00
       .byte $38 ; |  XXX   | $FD01
       .byte $38 ; |  XXX   | $FD02
       .byte $92 ; |X  X  X | $FD03
       .byte $54 ; | X X X  | $FD04
       .byte $38 ; |  XXX   | $FD05
       .byte $10 ; |   X    | $FD06
       .byte $10 ; |   X    | $FD07
       .byte $38 ; |  XXX   | $FD08
       .byte $44 ; | X   X  | $FD09
       .byte $82 ; |X     X | $FD0A
       .byte $00 ; |        | $FD0B
       .byte $38 ; |  XXX   | $FD0C
       .byte $38 ; |  XXX   | $FD0D
       .byte $90 ; |X  X    | $FD0E
       .byte $50 ; | X X    | $FD0F
       .byte $38 ; |  XXX   | $FD10
       .byte $14 ; |   X X  | $FD11
       .byte $12 ; |   X  X | $FD12
       .byte $38 ; |  XXX   | $FD13
       .byte $44 ; | X   X  | $FD14
       .byte $82 ; |X     X | $FD15
       .byte $00 ; |        | $FD16
       .byte $38 ; |  XXX   | $FD17
       .byte $38 ; |  XXX   | $FD18
       .byte $12 ; |   X  X | $FD19
       .byte $14 ; |   X X  | $FD1A
       .byte $38 ; |  XXX   | $FD1B
       .byte $50 ; | X X    | $FD1C
       .byte $90 ; |X  X    | $FD1D
       .byte $38 ; |  XXX   | $FD1E
       .byte $24 ; |  X  X  | $FD1F
       .byte $22 ; |  X   X | $FD20
       .byte $00 ; |        | $FD21
       .byte $38 ; |  XXX   | $FD22
       .byte $38 ; |  XXX   | $FD23
       .byte $10 ; |   X    | $FD24
       .byte $10 ; |   X    | $FD25
       .byte $38 ; |  XXX   | $FD26
       .byte $54 ; | X X X  | $FD27
       .byte $92 ; |X  X  X | $FD28
       .byte $38 ; |  XXX   | $FD29
       .byte $28 ; |  X X   | $FD2A
       .byte $28 ; |  X X   | $FD2B
       .byte $00 ; |        | $FD2C
       .byte $82 ; |X     X | $FD2D
       .byte $44 ; | X   X  | $FD2E
       .byte $38 ; |  XXX   | $FD2F
       .byte $10 ; |   X    | $FD30
       .byte $10 ; |   X    | $FD31
       .byte $FF ; |XXXXXXXX| $FD32
       .byte $FF ; |XXXXXXXX| $FD33
       .byte $00 ; |        | $FD34
       .byte $00 ; |        | $FD35
       .byte $00 ; |        | $FD36
       .byte $00 ; |        | $FD37
       .byte $82 ; |X     X | $FD38
       .byte $44 ; | X   X  | $FD39
       .byte $38 ; |  XXX   | $FD3A
       .byte $12 ; |   X  X | $FD3B
       .byte $14 ; |   X X  | $FD3C
       .byte $FF ; |XXXXXXXX| $FD3D
       .byte $FF ; |XXXXXXXX| $FD3E
       .byte $00 ; |        | $FD3F
       .byte $00 ; |        | $FD40
       .byte $00 ; |        | $FD41
       .byte $00 ; |        | $FD42
       .byte $22 ; |  X   X | $FD43
       .byte $24 ; |  X  X  | $FD44
       .byte $38 ; |  XXX   | $FD45
       .byte $90 ; |X  X    | $FD46
       .byte $50 ; | X X    | $FD47
       .byte $FF ; |XXXXXXXX| $FD48
       .byte $FF ; |XXXXXXXX| $FD49
       .byte $00 ; |        | $FD4A
       .byte $00 ; |        | $FD4B
       .byte $00 ; |        | $FD4C
       .byte $00 ; |        | $FD4D
       .byte $28 ; |  X X   | $FD4E
       .byte $28 ; |  X X   | $FD4F
       .byte $38 ; |  XXX   | $FD50
       .byte $92 ; |X  X  X | $FD51
       .byte $54 ; | X X X  | $FD52
       .byte $FF ; |XXXXXXXX| $FD53
       .byte $FF ; |XXXXXXXX| $FD54
       .byte $00 ; |        | $FD55
       .byte $00 ; |        | $FD56
       .byte $00 ; |        | $FD57
       .byte $00 ; |        | $FD58
       .byte $38 ; |  XXX   | $FD59
       .byte $38 ; |  XXX   | $FD5A
       .byte $10 ; |   X    | $FD5B
       .byte $10 ; |   X    | $FD5C
       .byte $38 ; |  XXX   | $FD5D
       .byte $54 ; | X X X  | $FD5E
       .byte $92 ; |X  X  X | $FD5F
       .byte $38 ; |  XXX   | $FD60
       .byte $28 ; |  X X   | $FD61
       .byte $28 ; |  X X   | $FD62
       .byte $00 ; |        | $FD63
       .byte $00 ; |        | $FD64



LFD65:
       STA    WSYNC                   ;3
       NOP                            ;2
       NOP                            ;2
       LDA    ($BC),Y                 ;5
       AND    #$F0                    ;2
       STA    PF1                     ;3
       LDA    ($BE),Y                 ;5
       ASL                            ;2
       ASL                            ;2
       ASL                            ;2
       ASL                            ;2
       STA    PF2                     ;3
       LDA    ($C4),Y                 ;5
       AND    #$F0                    ;2
       STA    PF1                     ;3
       LDA    ($C6),Y                 ;5
       ASL                            ;2
       ASL                            ;2
       ASL                            ;2
       ASL                            ;2
       STA    PF2                     ;3
       STA    WSYNC                   ;3
       LDA    ($BA),Y                 ;5
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       STA    PF1                     ;3
       LDA    ($C0),Y                 ;5
       AND    #$0F                    ;2
       STA    PF2                     ;3
       LDA    ($C2),Y                 ;5
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       LSR                            ;2
       STA    PF1                     ;3
       LDA    ($C8),Y                 ;5
       AND    #$0F                    ;2
       STA    PF2                     ;3
       DEY                            ;2
       BPL    LFD65                   ;2
       INY                            ;2
       STA    WSYNC                   ;3
       STY    CTRLPF                  ;3
       LDX    #$00                    ;2
       STX    PF0                     ;3
       STX    PF1                     ;3
       STX    PF2                     ;3
       LDX    #$05                    ;2
LFDB5:
       LDA    $84,X                   ;4
       STA.wy $BA,Y                   ;5
       INY                            ;2
       DEX                            ;2
       BPL    LFDB5                   ;2
       LDA    #$00                    ;2
       TAY                            ;2
       JMP    LFE96                   ;3 ???


LFE96:
       STA    WSYNC                   ;3
       STA    GRP0                    ;3
       LDX    $D6                     ;3
       CPY    $CE                     ;3
       BNE    LFEA1                   ;2
       INX                            ;2
LFEA1:
       LDA    $BF                     ;3
       STA    PF0                     ;3
       LDA    $BE                     ;3
       STA    PF1                     ;3
       LDA    $BD                     ;3
       STA    PF2                     ;3
       LDA    $BC                     ;3
       STA    PF0                     ;3
       LDA    $BB                     ;3
       STA    PF1                     ;3
       INY                            ;2
       LDA    $BA                     ;3
       STA    PF2                     ;3
       LDA    LFD00,X                 ;4
       BEQ    LFEC2                   ;2
       INX                            ;2
       STX    $D6                     ;3
LFEC2:
       DEC    $DA                     ;5
       BNE    LFE96                   ;2
       STA    WSYNC                   ;3
       STA    GRP0                    ;3
       LDA    #$06                    ;2
       STA    $D9                     ;3
       PLA                            ;4
       STA    COLUPF                  ;3
LFED1:
       LDA    #$00                    ;2
       STA    PF0                     ;3
       STA    PF1                     ;3
       STA    PF2                     ;3
       PLA                            ;4
       LDX    $D9                     ;3
       STA    $B9,X                   ;4
       LDX    $D6                     ;3
       CPY    $CE                     ;3
       BNE    LFEE5                   ;2
       INX                            ;2
LFEE5:
       LDA    LFD00,X                 ;4
       BEQ    LFEED                   ;2
       INX                            ;2
       STX    $D6                     ;3
LFEED:
       INY                            ;2
       CPY    #$1F                    ;2
       BEQ    LFF00                   ;2
       DEC    $D9                     ;5
       BEQ    LFE96                   ;2
       STA    WSYNC                   ;3
       STA    GRP0                    ;3
       LDA    #$06                    ;2
       STA    $DA                     ;3
       BNE    LFED1                   ;2
LFF00:
       STA    WSYNC                   ;3
       STA    GRP0                    ;3
       LDA    #$00                    ;2
       CPY    #$2A                    ;2
       BCS    LFF10                   ;2
       CPY    #$24                    ;2
       BCC    LFF10                   ;2
       LDA    $E6                     ;3
LFF10:
       STA    ENAM1                   ;3
       LDX    $CF                     ;3
       BNE    LFF1E                   ;2
       LDX    $DD                     ;3
       LDA    INPT0,X                 ;4
       BPL    LFF1E                   ;2
       STY    $CF                     ;3
LFF1E:
       LDX    $D6                     ;3
       CPY    $CE                     ;3
       BNE    LFF25                   ;2
       INX                            ;2
LFF25:
       LDA    LFD00,X                 ;4
       BEQ    LFF2D                   ;2
       INX                            ;2
       STX    $D6                     ;3
LFF2D:
       INY                            ;2
       CPY    #$A0                    ;2
       BNE    LFF00                   ;2
  IF FIX_SCANLINES
       STX    WSYNC                   ;3
       LDX    #$31                    ;2
       STX    CTRLPF                  ;3
       STX    PF0                     ;3
       LDX    #$0F                    ;2
       STX    COLUPF                  ;3
  ENDIF
       LDX    #$00                    ;2
LFF34:
       STA    WSYNC                   ;3
       STA    HMOVE                   ;3
       STA    GRP0                    ;3
       STX    GRP1                    ;3
       LDX    #$00                    ;2
       STX    COLUPF                  ;3
       STX    NUSIZ1                  ;3
       LDA    #$32                    ;2
       STA    PF0                     ;3
       STA    ENAM0                   ;3
       INX                            ;2
       STX    CTRLPF                  ;3
       LDX    $D6                     ;3
       CPY    $CE                     ;3
       BNE    LFF52                   ;2
       INX                            ;2
LFF52:
       LDA    LFD00,X                 ;4
       BEQ    LFF5A                   ;2
       INX                            ;2
       STX    $D6                     ;3
LFF5A:
       LDX    LFCB8,Y                 ;4
       INY                            ;2
       CPY    #$AE                    ;2
       BNE    LFF34                   ;2
       JMP    LF4B3                   ;3







START:
;original
;       SEI                            ;2
;       CLD                            ;2
;       LDX    #$FF                    ;2
;       TXS                            ;2
;       INX                            ;2
;       TXA                            ;2
;LF007:
;       STA    VSYNC,X                 ;4
;       INX                            ;2
;       BNE    LF007                   ;2

       CLD                            ;2 Clear decimal mode
       SEI                            ;2 and set the interrupt status
       LDA    #$00                    ;2 clear A
       TAY                            ;2 Console type = 2600
       LDX    $D0                     ;3 Check $D0
       CPX    #$2C                    ;2 Does it contain value $2C?
       BNE    Save_Console            ;2 If not, branch (keep 2600 mode)
       LDX    $D1                     ;3 Check $D1
       CPX    #$A9                    ;2 Does it contain value $A9?
       BNE    Save_Console            ;2 If not, branch (keep 2600 mode)
       LDY    #$80                    ;2 Otherwise, bump up Y (negative = 7800)
;note: I used the high bit for this ($00 or $80) to make checking quicker later (BPL/BMI)
Save_Console:
;now, clear out all ram
       TAX                            ;2 clear the X counter
Init_Ram_loop:
       DEX                            ;2 count down 1
       TXS                            ;2 give to the stack pointer
       PHA                            ;3 ...and push #$00 into ram
       BNE    Init_Ram_loop           ;2 branch 255 more times
;ram initialization done
       STY    $EB                     ;3 Now, save the console type
       LDY    SWCHB                   ;4
       STY    $EC                     ;3 ...and store current switches

       JSR    LF7D6                   ;6
       INC    $A8                     ;5
       LDA    LF809                   ;4
       STA    $E5                     ;3
       LDA    #$20                    ;2
       STA    NUSIZ0                  ;3
       JSR    LF04B                   ;6
       JSR    LF05B                   ;6
       DEC    $A9                     ;5
;       BMI    LF07C                   ;2
       BPL    LF024                   ;2
       JMP    LF07C                   ;3
LF024:
       LDA    VSYNC,X                 ;4
       ORA    RSYNC,X                 ;4
       AND    #$F0                    ;2
       ORA    NUSIZ0,X                ;4
       ORA    VBLANK,X                ;4
       ORA    WSYNC,X                 ;4
       ORA    NUSIZ1,X                ;4
       BEQ    LF037                   ;2
       LDA    #$00                    ;2
       RTS                            ;6

LF037:
       LDA    #$AA                    ;2
       STA    VBLANK,X                ;4
       STA    NUSIZ0,X                ;4
       LDA    #$55                    ;2
       STA    WSYNC,X                 ;4
       STA    NUSIZ1,X                ;4
       AND    #$F0                    ;2
       STA    VSYNC,X                 ;4
       STA    RSYNC,X                 ;4
       TYA                            ;2
       RTS                            ;6

LF04B:
       CLC                            ;2
       LDA    #$84                    ;2
       TAX                            ;2
LF04F:
       JSR    LF037                   ;6
       TXA                            ;2
       ADC    #$06                    ;2
       TAX                            ;2
       CMP    #$A8                    ;2
       BNE    LF04F                   ;2
       RTS                            ;6

LF05B:
       LDA    #$B0                    ;2
       STA    $CE                     ;3
       STA    $D0                     ;3
       ASL                            ;2
       STA    $E4                     ;3
       LDX    #$02                    ;2
       LDA    $81                     ;3
       LSR                            ;2
       BCS    LF06D                   ;2
       LDX    #$9B                    ;2
LF06D:
       STX    $CD                     ;3
       LDA    #$0C                    ;2
       STA    $DE                     ;3
       LDX    #$00                    ;2
       STX    $D1                     ;3
       STX    $D6                     ;3
       STX    $E1                     ;3
       RTS                            ;6



       ORG $FFF8
       .byte "2006"
       .word START,0
